--[[
==myHonor==
By Smokey aka Mahuatahu on Earthen Ring Horde US

==To do list==
2.) (maybe?) own GUI instead of data broker --too lazy now, convenient when built into Titan Panel or FuBar
3.) BG WEEKEND
==Changelog==
1.4.2: *When you tried to display goals on the bar when they were 0 you would get a nil error, this is fixed.
1.4.1: *Updated help *Choice to auto hide quest tracker upon entry to arena or battlegrounds *slash command available for tool tip change for macros etc
1.4.0: Conquest Tooltip! More Colors, other stuff.
1.3.2: Pesky nil error on line 191 should be fixed.
1.3.1: Conquest points! probably going to move to it's own addon shortly since Honor is taking up a huge portion.
1.3.0: Finally functional BG Count. Fixed some errors along the way.  Updates to Localization.
--]]

--GetBattlegroundInfo(i) space 5 THIS IS FOR HOLIDAY. USE IT LATER BRO
-- with GetNumBattlegroundTypes()

local mhVersion = "1.4.2"
local mhAddon = "myHonor"
local mqVersion = "1.4.2"
local mqAddon = "myConquest"

-- Short configuration
local useSI = true					--[[	true: SI-units, e.g. 3.2k instead of 3230			]]
-- Configuration end

-- Initializing the object and frame
local honorIcon = "Interface\\PVPFrame\\PVP-Currency-"..UnitFactionGroup("player")
local conquestIcon = "Interface\\PVPFrame\\PVPCurrency-Conquest-"..UnitFactionGroup("player")
local OnEvent = function(self, event, ...) self[event](self, event, ...) end
local dataobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("myHonor", {
	type = "data source",
	icon = honorIcon,
})
local myHonor = {}
local frame = CreateFrame"Frame"

-- [[    Varibles, etc    ]] --
local session, total, startTime
local mhTooltip = 1
local HonorGained, SessionHonor, StartingHonor, BGHonor, LastBG, HonorBefore = 0, 0, 0, 0, 0, 0, 0, 0, 0
local ConqTotal, StartingConquest = 0, 0
local HonorGained_InBG = 0
local BGCount, AvgHonor, EnteredBG, InBG, perHour = 0,0,0,0,0
local FinallyLoaded, AddonLded, AutoJoinBG, LastDate = nil, nil, nil, nil
local VarisLoaded = false
local myHonor_BGCONF = 0
local myHonor_BGAUTOJOINTIMER = 30
local HonorGoal, HonorGoalFinal, ConquestGoalFinal, ConquestGoal = 0, 0, 0, 0
local Splashed = 0
local mhDisplay, mqDisplay = 1, 1
local mhHonorToday, mhHonorYesterday = 0, 0
local BGTotal = 0
local StartingHKs, SessionHKs, TotalHKs = 0,0,0
local ConquestGained, SessionCP, BGConquest, LastBG, ConquestBefore = 0, 0, 0, 0, 0, 0, 0, 0
local ConquestGained_InBG = 0
local WGCount, AvgCP, EnteredWG, InWG = 0,0,0,0
local ConqCap, ConqCapTotal = 0, 0
local mhAutoQuest, mhAutoShow = 1, 0


--[[   Initialize all variables    ]] --
function frame:PLAYER_ENTERING_WORLD()
	if(not myHonor) then
	myHonor = {}
	end
	if (not startTime) then
		startTime = time()
--		CptHook:HookScript(AuctionsButton, "OnClick", "AHTT")
	end
    HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
	  ZoneInfo = (select(2, IsInInstance()))
	  InBG = 0
	  if (ZoneInfo == "pvp") then
	     InBG = 1 --In a battleground
 	     BGCount = BGCount + 1
		 BGTotal = BGTotal + 1
	     HonorGained_InBG = HonorGained_InBG + BGHonor
	     LastBG = BGHonor
	     BGHonor = 0
         HonorBefore = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
		 if (mhAutoQuest==1) then
		 	if (mhAutoHide==0) then
				 WatchFrame_Collapse(WatchFrame)
				 mhAutoHide = 1
			end
		 end
	  elseif (ZoneInfo == "none") then
		 if (mhAutoQuest==1) then
		 	if (mhAutoHide==1) then
				 WatchFrame_Collapse(WatchFrame)
				 mhAutoHide = 0
			end
		 end
	     InBG = 0 --Not in a battleground
	  elseif (ZoneInfo == "arena") then
	  	 InWG = 1
		 WGCount = WGCount + 1
		 ConquestGained_InBG = ConquestGained_InBG + WGHonor
	     LastWG = WGHonor
	     WGHonor = 0
         ConquestBefore = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY)))
		 if (mhAutoQuest==1) then
		 	if (mhAutoHide==0) then
				 WatchFrame_Collapse(WatchFrame)
				 mhAutoHide = 1
			end
		 end
	  end
	
	if (FinallyLoaded==nil) then
	self:CheckHonor()
	end
end

---------------------
--Currency updating--
---------------------
function frame:CURRENCY_DISPLAY_UPDATE()



HonorGained = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
ConqTotal = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY)))
if (FinallyLoaded==true) then
SessionHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - StartingHonor
SessionCP = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY))) - StartingConquest
SessionHKs = GetPVPLifetimeStats() - StartingHKs
if (mhHonorToday==SessionHonor) then
mhHonorToday = mhHonorToday + tonumber(SessionHonor)
else
mhHonorToday = tonumber(SessionHonor)
end
TotalHKs = GetPVPLifetimeStats()
ConqCap = (select(5,GetCurrencyInfo(CONQUEST_CURRENCY)))
ConqCapTotal = (select(4,GetCurrencyInfo(CONQUEST_CURRENCY)))


if (not LastDate==string.sub(date(),0,8)) then --different day, clear honor today

end
	

end
if (InBG==1) then
BGHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY))) - HonorBefore
BGConquest = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY))) - ConquestBefore
end
if (BGCount>0) then
AvgHonor = HonorGained_InBG / BGCount   
end
if (WGCount>0) then
AvgCP = ConquestGained_InBG / WGCount   
end

if (Splashed==0) then

	if (HonorGoal==0) then
	--
	elseif (HonorGoal<HonorGained) then

		CombatText_AddMessage(myHonor_TXT_GOALMET, CombatText_StandardScroll, 1, 0.50, 0)
		RaidNotice_AddMessage(RaidWarningFrame, myHonor_TXT_GOALMET, ChatTypeInfo["RAID_WARNING"])
		DEFAULT_CHAT_FRAME:AddMessage(myHonor_TXT_GOALMET, 1, 0.50, 0)
		PlaySound("RaidWarning")
		Splashed = 1

	end
	
	if (ConquestGoal==0) then
	--
	elseif (ConquestGoal<ConqTotal) then

		CombatText_AddMessage(mq_TXT_GOALMET, CombatText_StandardScroll, 1, 0.50, 0)
		RaidNotice_AddMessage(RaidWarningFrame, mq_TXT_GOALMET, ChatTypeInfo["RAID_WARNING"])
		DEFAULT_CHAT_FRAME:AddMessage(mq_TXT_GOALMET, 1, 0.50, 0)
		PlaySound("RaidWarning")
		Splashed = 1

	end

end

if (ConquestGoal>0) then
	ConquestGoalFinal = ConquestGoal - ConqTotal
end
if (ConquestGoal<ConqTotal) then
	ConquestGoalFinal = GreenText("N/A")
end

if (HonorGoal>0) then
	HonorGoalFinal = HonorGoal - HonorGained
else
	HonorGoalFinal = 0
end
if (HonorGoal<HonorGained) then
	HonorGoalFinal = GreenText("N/A")
end

if (mhDisplay==1) then
	dataobj.value = HonorGained
	dataobj.text = Should_I_Be_Red(HonorGained)..myHonor_BAR_ONE
elseif (mhDisplay==2) then
	dataobj.value = SessionHonor
	dataobj.text = Should_I_Be_Red(SessionHonor)..myHonor_BAR_TWO
elseif (mhDisplay==3) then
	dataobj.value = HonorGoalFinal
	dataobj.text = HonorGoalFinal..myHonor_BAR_THREE
elseif (mhDisplay==4) then
	dataobj.value = BGHonor
	dataobj.text = Should_I_Be_Red(BGHonor)..myHonor_BAR_FOUR
elseif (mhDisplay==5) then
	dataobj.value = AvgHonor
	dataobj.text = Should_I_Be_Red(AvgHonor)..myHonor_BAR_FIVE
elseif (mhDisplay==6) then
	dataobj.value = TotalHKs
	dataobj.text = Should_I_Be_Red(TotalHKs)..myHonor_BAR_SIX
elseif (mhDisplay==7) then
	dataobj.value = SessionHKs
	dataobj.text = Should_I_Be_Red(SessionHKs)..myHonor_BAR_SEVEN
elseif (mhDisplay==8) then
	dataobj.value = ConqTotal
	dataobj.text = Should_I_Be_Red(ConqTotal)..myHonor_BAR_EIGHT
elseif (mhDisplay==9) then
	dataobj.value = SessionCP
	dataobj.text = Should_I_Be_Red(SessionCP)..myHonor_BAR_NINE
elseif (mhDisplay==10) then
	dataobj.value = ConquestGoalFinal
	dataobj.text = ConquestGoalFinal..myHonor_BAR_TEN
elseif (mhDisplay==11) then
	dataobj.value = AvgCP
	dataobj.text = Should_I_Be_Red(AvgCP)..myHonor_BAR_ELEVEN
elseif (mhDisplay==12) then
	dataobj.value = ConqCap
	dataobj.text = Should_I_Be_Red(ConqCapTotal).."/"..GreenText(ConqCap)..myHonor_BAR_TWELVE
end

end

function frame:ADDON_LOADED(arg1)

--if (arg1=="myHonor") then --good to go, set variables
if (VarisLoaded==true) then
return;
else
	if (myHonor_AJBG) then AutoJoinBG = myHonor_AJBG end
	if (myHonor_DATE) then LastDate = myHonor_DATE end
	if (myHonor_Goal) then HonorGoal = myHonor_Goal end
	if (myHonor_Display) then mhDisplay = myHonor_Display end
	if (myHonor_HonorToday) then mhHonorToday = myHonor_HonorToday end
	if (myHonor_HonorYesterday) then mhHonorYesterday = myHonor_HonorYesterday end
	if (mh_BGCount) then BGTotal = tonumber(mh_BGCount) end
	if (mhTTDisplay) then mhTooltip = mhTTDisplay end
	if (myConquest_Goal) then ConquestGoal = myConquest_Goal end
	if (myConquest_Display) then mqDisplay = myConquest_Display end
	if (mq_BGCount) then WGTotal = tonumber(mq_BGCount) end
	if (myHonor_AHQ) then mhAutoQuest = myHonor_AHQ end
	VarisLoaded = true
	if (LastDate) then
	if (tonumber(string.sub(LastDate,4,5))==tonumber((string.sub(date(),4,5)-1))) then --yesterday
		BGTotal = 0
		mh_BGCount = 0
		mhHonorYesterday = mhHonorToday
		mhHonorToday = 0
	else
		mhHonorToday = 0
		mhHonorYesterday = 0
	end
	end

end

end

function frame:PLAYER_LEAVING_WORLD()

if (Splashed==1) then
HonorGoal = 0
ConquestGoal = 0
end

self:SaveStuff()

end

function frame:PLAYER_LOGOUT()

self:SaveStuff()

end

function frame:SaveStuff()

local TheDate = string.sub(date(),0,8)

myHonor_AJBG = AutoJoinBG
myHonor_DATE = TheDate
myHonor_Goal = HonorGoal
myHonor_Display = mhDisplay
myHonor_HonorToday = mhHonorToday
myHonor_HonorYesterday = mhHonorYesterday
mh_BGCount = BGTotal
mhTTDisplay = mhTooltip
myHonor_AHQ = mhAutoQuest

myConquest_DATE = TheDate
myConquest_Goal = ConquestGoal
myConquest_Display = mqDisplay
mq_BGCount = WGTotal

end

function frame:UPDATE_BATTLEFIELD_STATUS()

--Work in progress, i'm convinced it is no longer possible to do this with an add-on.
--self:mhAutoBattle()

end

frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent"PLAYER_ENTERING_WORLD"
frame:RegisterEvent"PLAYER_LEAVING_WORLD"
frame:RegisterEvent"CURRENCY_DISPLAY_UPDATE"
frame:RegisterEvent"ADDON_LOADED"
frame:RegisterEvent"PLAYER_LOGOUT"
frame:RegisterEvent"UPDATE_BATTLEFIELD_STATUS"

-- [[   The tooltip  ]] --
function dataobj.OnTooltipShow(tooltip)

	 local hc, InBGtext, pname, rname, fname = 0, 0, 0, 0, 0
     pname = GetHighText(UnitName("player"))
     rname = GreenText(GetCVar("realmname"))
     fname = UnitFactionGroup("player")
     hc = GetPVPLifetimeStats()
	 local sessionTime = time() - startTime
	 local AJBGtext
	 local HonorGoalFinal, HonorGoalTime, ConquestGoalFinal, ConquestGoalTime = 0, 0, 0, 0
     if (InBG==1) then
     	InBGtext = RedText(GetZoneText())
     	else 
     	InBGtext = GreenText("No")
     end
	 if (AutoJoinBG==true) then
	 	AJBGtext = "Enabled"
	 	else
	 	AJBGtext = "Disabled"
	 end
--which tooltip to select, Honor or Conquest
 if (mhTooltip==1) then
	if (SessionHonor>0) then
		if (startTime) then perHour = SessionHonor / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (HonorGoal>0) then
	 	HonorGoalFinal = HonorGoal - HonorGained
		if (BGCount>0) then
			if (AvgHonor>0) then
				HonorGoalTime = HonorGoalFinal/AvgHonor
				HonorGoalTime = format("%d",HonorGoalTime)
			else
				HonorGoalTime = "N/A"
			end
		else
			HonorGoalTime = "N/A"
		end
	 else
	 	HonorGoalFinal = "N/A"
	 end
	 if (HonorGoal==0) then
	 HonorGoalTime = GetHighText("N/A")
	 elseif (HonorGoal<HonorGained) then
		HonorGoalFinal = GreenText("Goal Accomplished!")
	 end
	-- Arena points
	--local arena = GetArenaCurrency()
	--if(arena > 0) then
	--	tooltip:AddDoubleLine("Arena points:", arena.." "..texturizeIcon(arenaIcon), 1,1,1, 0,1,0)
	--end

	tooltip:AddLine(pname.." - "..rname.." ("..fname..")")
	tooltip:AddLine(GetHighText(mhAddon.." v"..mhVersion))
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(myHonor_TT_STATUS,InBGtext)
	tooltip:AddDoubleLine(myHonor_TT_TOTALPTS,GetHighText(StartingHonor))
	tooltip:AddDoubleLine(myHonor_TT_TOTALHKS,GetHighText(hc))
	--tooltip:AddDoubleLine(myHonor_TT_TODAYPTS,GetHighText(mhHonorToday))
	--tooltip:AddDoubleLine(myHonor_TT_YESPTS,GetHighText(mhHonorYesterday))
	tooltip:AddDoubleLine(myHonor_TT_TOTALCONQ,GetHighText(ConqTotal))
	tooltip:AddLine("----------------------------------")
	tooltip:AddLine(GetHighText(myHonor_TT_SESSIONSTATS))
	tooltip:AddDoubleLine(myHonor_TT_SESSIONPTS,Should_I_Be_Red(SessionHonor))
	tooltip:AddDoubleLine(myHonor_TT_SESSIONHKS,Should_I_Be_Red(SessionHKs))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(GetHighText(myHonor_TT_BGSTATS))
	tooltip:AddDoubleLine(myHonor_TT_LASTBG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(myHonor_TT_BGHONOR,Should_I_Be_Red(BGHonor))
	tooltip:AddDoubleLine(myHonor_TT_AVGHONOR,Should_I_Be_Red(format("%d",AvgHonor)))
	tooltip:AddDoubleLine(myHonor_TT_BGCOUNT,Should_I_Be_Red(BGCount))
	--tooltip:AddDoubleLine(myHonor_TT_BGTTL,Should_I_Be_Red(BGTotal))
	tooltip:AddDoubleLine(myHonor_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(myHonor_TT_GOALTEXT,GreenText(HonorGoal))
	tooltip:AddDoubleLine(myHonor_TT_GOALTEXT2,GetHighText(HonorGoalFinal))
	tooltip:AddDoubleLine(myHonor_TT_GOALTIME,GreenText("~"..HonorGoalTime))
	--tooltip:AddLine("----------------------------------")
	--tooltip:AddDoubleLine(myHonor_TT_AJBG, GetHighText(AJBGtext))
	tooltip:AddLine(" ")
	tooltip:AddLine(myHonor_TT_CLICKTOGGLE)
	tooltip:AddLine(GreenText(myHonor_TT_CLICKPVP),nil,nil,nil,1)
	tooltip.updateFunction = dataobj.OnTooltipShow
 else
 --conquest
 if (SessionCP>0) then
		if (startTime) then perHour = SessionCP / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (ConquestGoal>0) then
	 	ConquestGoalFinal = ConquestGoal - ConqTotal
		if (WGCount>0) then
			if (AvgCP>0) then
				ConquestGoalTime = ConquestGoalFinal/AvgCP
				ConquestGoalTime = format("%d",ConquestGoalTime)
			else
				ConquestGoalTime = "N/A"
			end
		else
			ConquestGoalTime = "N/A"
		end
	 else
	 	ConquestGoalFinal = "N/A"
	 end
	 if (ConquestGoal==0) then
	 ConquestGoalTime = GetHighText("N/A")
	 elseif (ConquestGoal<ConqTotal) then
		ConquestGoalFinal = GreenText("Goal Accomplished!")
	 end
	tooltip:AddLine(pname.." - "..rname.." ("..fname..")")
	tooltip:AddLine(GetHighText(mqAddon.." v"..mqVersion))
	tooltip:AddLine(" ")
	tooltip:AddDoubleLine(mq_TT_STATUS,InBGtext)
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(GetHighText(mq_TT_WGSTATS))
	tooltip:AddDoubleLine(mq_TT_LASTWG,Should_I_Be_Red(LastBG))
	tooltip:AddDoubleLine(mq_TT_SESSIONCP,Should_I_Be_Red(SessionCP))
	tooltip:AddDoubleLine(mq_TT_AVGPTS,Should_I_Be_Red(format("%d",AvgCP)))
	tooltip:AddDoubleLine(mq_TT_BGCOUNT,Should_I_Be_Red(WGCount))
	tooltip:AddDoubleLine(mq_TT_CAP,Should_I_Be_Red(ConqCapTotal).."/"..GreenText(ConqCap))
	tooltip:AddDoubleLine(mq_TT_PERHR,Should_I_Be_Red(format("%d",perHour)))
	tooltip:AddLine("----------------------------------")
	tooltip:AddDoubleLine(mq_TT_GOALTEXT,GreenText(ConquestGoal))
	tooltip:AddDoubleLine(mq_TT_GOALTEXT2,GetHighText(ConquestGoalFinal))
	tooltip:AddDoubleLine(mq_TT_GOALTIME,GreenText("~"..ConquestGoalTime))
	tooltip:AddLine(" ")
	tooltip:AddLine(myHonor_TT_CLICKTOGGLE)
	tooltip:AddLine(GreenText(myHonor_TT_CLICKPVP),nil,nil,nil,1)
	tooltip.updateFunction = dataobj.OnTooltipShow
 end
end

SLASH_GOAL1 = "/goal"
function SlashCmdList.GOAL(msg)

local cmd = msg:lower()

if (cmd=="") then
	
	ShortPrint(myHonor_TXT_GOALSYN)

elseif (tonumber(msg)>40000) then

	ShortPrint(myHonor_TXT_GOALERR)
	
else

	if (mhTooltip==1) then
	--honor
		HonorGoal = tonumber(msg)
		ShortPrint(myHonor_TXT_GOALSET..HonorGoal)
		Splashed = 0
		if (mhDisplay==3) then
			local HonorGoalFinal = 0
			if (HonorGoal>0) then
				HonorGoalFinal = HonorGoal - HonorGained
			end
			if (HonorGoal<HonorGained) then
				HonorGoalFinal = GreenText("N/A")
			end
			dataobj.value = HonorGoalFinal
			dataobj.text = HonorGoalFinal.." until Goal"
		end
	
	else
	
	--conquest
		ConquestGoal = tonumber(msg)
		ShortPrint(mq_TXT_GOALSET..ConquestGoal)
		Splashed = 0
		--[[if (mhDisplay==3) then
			local HonorGoalFinal = 0
			if (HonorGoal>0) then
				HonorGoalFinal = HonorGoal - HonorGained
			end
			if (HonorGoal<HonorGained) then
				HonorGoalFinal = GreenText("N/A")
			end
			dataobj.value = HonorGoalFinal
			dataobj.text = HonorGoalFinal.." until Goal"
		end]]--
	
	end
	
end

end

SLASH_AJBG1 = "/mh"
function SlashCmdList.AJBG(msg)
local cmd = msg:lower()

if (cmd=="ahquest") then
	if (mhAutoQuest==0) then
		mhAutoQuest = 1
		ShortPrint("Auto Quest Tracker Hider ON")
	else
		mhAutoQuest = 0
		ShortPrint("Auto Quest Tracker Hider OFF")
	end
elseif (cmd=="tt") then
if (mhTooltip==1) then
	mhTooltip = 2
elseif (mhTooltip==2) then
	mhTooltip = 1
end
elseif (cmd=="goal") then
ShortPrint(myHonor_TXT_GOALSYN)
elseif (cmd=="help") then
ShortPrint(myHonor_HELP_ONE)
ShortPrint(myHonor_HELP_TWO)
ShortPrint(myHonor_HELP_THREE)
ShortPrint(myHonor_HELP_FOUR)
ShortPrint(myHonor_HELP_FIVE..mhVersion)
elseif (cmd=="secret") then
print("Saved date: "..myHonor_DATE)
print("Saved DAY: "..string.sub(LastDate,4,5))
print("Current DAY: "..string.sub(date(),4,5))
print("yesterDAY: "..tonumber(string.sub(date(),4,5))-1)
elseif (cmd=="print") then
self:mh_Print()
end

end

function ShortPrint(text)

return DEFAULT_CHAT_FRAME:AddMessage(text, 0.41, 0.80, 0.94)

end

function frame:CallAJBG()

if (AutoJoinBG==true) then
	AutoJoinBG=false
	else
	AutoJoinBG=true
end

end

function dataobj.OnClick(self, button)
	if(button == "RightButton") then
		--TogglePVPFrame()
		if (mhTooltip==1) then
			mhTooltip = 2
		elseif (mhTooltip==2) then
			mhTooltip = 1
		end
	else
		if (mhTooltip) then
			if (mhDisplay==12) then
				mhDisplay = 1
			else
				mhDisplay = mhDisplay + 1
			end
		--[[elseif (mhToolTip==2) then
			if (mqDisplay==4) then
				mqDisplay = 1
			else
				mqDisplay = mqDisplay +1
			end]]--
		end

	end
	
	frame:CURRENCY_DISPLAY_UPDATE()
	
end

function GreenText(text)

	if (text) then
		return "|cff00ff00"..text.."|r"
	end 

end

function RedText(text)

	if (text) then
		return "|cffff0000"..text.."|r"
	end 

end

function BlueText(text)

	if (text) then
		return "|cff0000ff"..text.."|r"
	end 

end

function GetHighText(text)

	if (text) then
		return "|cffffffff"..text.."|r"
	end

end

function Should_I_Be_Red(text)
	if (text=="N/A") then
		return GreenText(text)
	elseif (tonumber(text)) then
		if (tonumber(format("%d",text))<=0) then
			return RedText(text)
		else
			return GreenText(text)
		end
	end
end

function frame:CheckHonor()

if (FinallyLoaded==nil) then
StartingHonor = (select(2,GetCurrencyInfo(HONOR_CURRENCY)))
StartingHKs = GetPVPLifetimeStats()
StartingConquest = (select(2,GetCurrencyInfo(CONQUEST_CURRENCY)))
FinallyLoaded = true
end

end

local function siUnits(value)
	if(not useSI) then
		return value
	elseif(not value or value == 0) then
		return 0
	elseif(value >= 10^3) then
		return ("%.1fk"):format(value / 10^3)
	elseif(value >= 10^6) then
		return ("%.1fm"):format(value / 10^6)
	else
		return value
	end
end

local function texturizeIcon(arg1)
	return format("|T%s:15:15:0:0|t", type(arg1) == "number" and GetItemIcon(arg1) or arg1)
end

function frame:mh_Print()

	 local hc, InBGtext, pname, rname, fname = 0, 0, 0, 0, 0
     pname = GetHighText(UnitName("player"))
     rname = GreenText(GetCVar("realmname"))
     fname = UnitFactionGroup("player")
     hc = GetPVPLifetimeStats()
	 local sessionTime = time() - startTime
	 local AJBGtext
	 local HonorGoalFinal, HonorGoalTime, ConquestGoalFinal, ConquestGoalTime = 0, 0, 0, 0
     if (InBG==1) then
     	InBGtext = RedText(GetZoneText())
     	else 
     	InBGtext = GreenText("No")
     end
	 if (AutoJoinBG==true) then
	 	AJBGtext = "Enabled"
	 	else
	 	AJBGtext = "Disabled"
	 end
--which tooltip to select, Honor or Conquest
 if (mhTooltip==1) then
	if (SessionHonor>0) then
		if (startTime) then perHour = SessionHonor / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (HonorGoal>0) then
	 	HonorGoalFinal = HonorGoal - HonorGained
		if (BGCount>0) then
			if (AvgHonor>0) then
				HonorGoalTime = HonorGoalFinal/AvgHonor
				HonorGoalTime = format("%d",HonorGoalTime)
			else
				HonorGoalTime = "N/A"
			end
		else
			HonorGoalTime = "N/A"
		end
	 else
	 	HonorGoalFinal = "N/A"
	 end
	 if (HonorGoal==0) then
	 HonorGoalTime = GetHighText("N/A")
	 elseif (HonorGoal<HonorGained) then
		HonorGoalFinal = GreenText("Goal Accomplished!")
	 end

	print(pname.." - "..rname.." ("..fname..")")
	print(GetHighText(mhAddon.." v"..mhVersion))
	print(" ")
	print(myHonor_TT_STATUS.."		"..InBGtext)
	print(myHonor_TT_TOTALPTS.."		"..GetHighText(StartingHonor))
	print(myHonor_TT_TOTALHKS.."		"..GetHighText(hc))
	--print(myHonor_TT_TODAYPTS.."		"..GetHighText(mhHonorToday))
	--print(myHonor_TT_YESPTS.."		"..GetHighText(mhHonorYesterday))
	print(myHonor_TT_TOTALCONQ.."		"..GetHighText(ConqTotal))
	print("----------------------------------")
	print(GetHighText(myHonor_TT_SESSIONSTATS))
	print(myHonor_TT_SESSIONPTS.."		"..Should_I_Be_Red(SessionHonor))
	print(myHonor_TT_SESSIONHKS.."		"..Should_I_Be_Red(SessionHKs))
	print("----------------------------------")
	print(GetHighText(myHonor_TT_BGSTATS))
	print(myHonor_TT_LASTBG.."		"..Should_I_Be_Red(LastBG))
	print(myHonor_TT_BGHONOR.."		"..Should_I_Be_Red(BGHonor))
	print(myHonor_TT_AVGHONOR.."		"..Should_I_Be_Red(format("%d".."		"..AvgHonor)))
	print(myHonor_TT_BGCOUNT.."		"..Should_I_Be_Red(BGCount))
	print(myHonor_TT_PERHR.."		"..Should_I_Be_Red(format("%d".."		"..perHour)))
	print("----------------------------------")
	print(myHonor_TT_GOALTEXT.."		"..GreenText(HonorGoal))
	print(myHonor_TT_GOALTEXT2.."		"..GetHighText(HonorGoalFinal))
	print(myHonor_TT_GOALTIME.."		"..GreenText("~"..HonorGoalTime))
	print(" ")
	print(myHonor_TT_CLICKTOGGLE)
	print(GreenText(myHonor_TT_CLICKPVP).."		"..nil.."		"..nil.."		"..nil.."		"..1)
 else
 --conquest
 if (SessionCP>0) then
		if (startTime) then perHour = SessionCP / sessionTime * 3600 end
	else
		perHour = 0
	end
	--xpPerHour = 
	if (fname=="Alliance") then
        fname = BlueText(UnitFactionGroup("player"))
     else
        fname = RedText(UnitFactionGroup("player"))
     end
	 if (ConquestGoal>0) then
	 	ConquestGoalFinal = ConquestGoal - ConqTotal
		if (WGCount>0) then
			if (AvgCP>0) then
				ConquestGoalTime = ConquestGoalFinal/AvgCP
				ConquestGoalTime = format("%d".."		"..ConquestGoalTime)
			else
				ConquestGoalTime = "N/A"
			end
		else
			ConquestGoalTime = "N/A"
		end
	 else
	 	ConquestGoalFinal = "N/A"
	 end
	 if (ConquestGoal==0) then
	 ConquestGoalTime = GetHighText("N/A")
	 elseif (ConquestGoal<ConqTotal) then
		ConquestGoalFinal = GreenText("Goal Accomplished!")
	 end
	print(pname.." - "..rname.." ("..fname..")")
	print(GetHighText(mqAddon.." v"..mqVersion))
	print(" ")
	print(mq_TT_STATUS.."		"..InBGtext)
	print("----------------------------------")
	print(GetHighText(mq_TT_WGSTATS))
	print(mq_TT_LASTWG.."		"..Should_I_Be_Red(LastBG))
	print(mq_TT_SESSIONCP.."		"..Should_I_Be_Red(SessionCP))
	print(mq_TT_AVGPTS.."		"..Should_I_Be_Red(format("%d".."		"..AvgCP)))
	print(mq_TT_BGCOUNT.."		"..Should_I_Be_Red(WGCount))
	print(mq_TT_CAP.."		"..Should_I_Be_Red(ConqCapTotal).."/"..GreenText(ConqCap))
	print(mq_TT_PERHR.."		"..Should_I_Be_Red(format("%d".."		"..perHour)))
	print("----------------------------------")
	print(mq_TT_GOALTEXT.."		"..GreenText(ConquestGoal))
	print(mq_TT_GOALTEXT2.."		"..GetHighText(ConquestGoalFinal))
	print(mq_TT_GOALTIME.."		"..GreenText("~"..ConquestGoalTime))
	print(" ")
	print(myHonor_TT_CLICKTOGGLE)
	print(GreenText(myHonor_TT_CLICKPVP))
 end
end

--word, opyright Smokey, 2010 All Rights Reserved, released under GNU License #3.
--if you're going to edit, at least give me credit or tell me about it and we can work together
--2010